<?php

namespace app\modules\documents\models;

use app\helpers\FileHelper;
use app\models\BaseModel;
use app\modules\documents\models\query\DocumentQuery;
use Yii;
use yii\base\ErrorException;
use yii\helpers\Html;
use yii\helpers\Url;
use yii\imagine\Image;
use yii\web\NotFoundHttpException;
use yii\web\UploadedFile;

/**
 * This is the model class for table "{{%document}}".
 *
 * @property int $id
 * @property int $id_user
 * @property string $name
 * @property string $extension
 * @property string $public
 * @property string|null $title Custom title to be displayed to users. If empty, name will be used.
 * @property string|null $description Custom long text that can describe the document.
 * @property int $bytes
 * @property string $mime
 * @property int|null $width If the document is an image
 * @property int|null $height If the document is an image
 */
class Document extends BaseModel
{
    public ?UploadedFile $uploadedFile = null;

    public int $folderPermissions = 750; // chmod-calculator.com
    public int $thumbnail_width = 300;
    public int $thumbnail_height = 300;

    public string $docUploadFolder = '@app/uploads';
    public string $docUploadFolderPublic = '@app/web/uploads'; // absolute path on the server. Do not use @web alias.

    public ?array $allowedExtensions = null;
    /**
     * Values 0-100. -1 = default value. Search for word "quality" for example in class:
     * vendor/imagine/imagine/src/Gd/Image.php
     * @var int
     */
    public int $thumbnail_quality = 80;

    /**
     * {@inheritdoc}
     */
    public static function tableName(): string
    {
        return '{{%document}}';
    }

    public static function createFromFile(int $idUser, string $filePath): Document
    {
        $document = new Document();
        $document->id_user = $idUser;
        $document->setFileInfo($filePath);
        $document->save();
        rename($filePath, $document->getPath());
        return $document;
    }

    public static function getAllFiles_listData(bool $groupByPublic = true): array
    {
        $result = [];
        foreach (Document::find()->orderBy(['name' => SORT_ASC])->all() as $document) {
            if ($groupByPublic) {
                $public = Yii::t('app.documents', 'Public');
                $secured = Yii::t('app.documents', 'Secured');
                if ((int)$document->public) {
                    $result[$public][$document->getUrl(false)] = $document->name;
                } else {
                    $result[$secured][$document->getUrl(false)] = $document->name;
                }
            } else {
                $result[$document->getUrl(false)] = $document->name;
            }
        }
        return $result;
    }

    /**
     * {@inheritdoc}
     * @return \appmodules\doc\models\query\DocumentQuery the active query used by this AR class.
     */
    public static function find(): DocumentQuery
    {
        return new DocumentQuery(get_called_class());
    }

    public function loadDefaultValues($skipIfSet = true)
    {
        $this->uploadedFile = null;
        return parent::loadDefaultValues($skipIfSet); // TODO: Change the autogenerated stub
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['description'], 'string'],
            [['title'], 'string', 'max' => 255],
            [['public'], 'boolean'],
            [['uploadedFile'], 'file', 'skipOnEmpty' => true, 'extensions' => $this->allowedExtensions, 'maxSize' => $this->maxFileSize(), 'checkExtensionByMimeType' => false],
        ];
    }

    /**
     * Returns max file size. If you need to change this value for certain file types, you can do in this method.
     * @return int
     */
    public function maxFileSize(): int
    {
        return 5 * 1024 * 1024;
    }

    /**
     * @throws ErrorException
     */
    public function upload(): bool
    {
        if ($this->getIsNewRecord()) {
            throw new ErrorException('Upload is possible only when the Document was already saved.');
        }

        $docUploadFolder = $this->getDocUploadFolderAbs();

        if (!file_exists(realpath($docUploadFolder))) {
            try {
                mkdir(($docUploadFolder), $this->folderPermissions, true);
            } catch (\Exception $ex) {
                Yii::error("PHP cannot create folder $docUploadFolder");
                return false;
            }
        }
        if ($this->uploadedFile->saveAs($this->getPath())) {
            if ($this->isUploadedfileImage(false)) {
                // Generate a thumbnail image
                Image::thumbnail($this->getPath(), $this->thumbnail_width, $this->thumbnail_height)->save($this->getThumbnailPath(), ['quality' => $this->thumbnail_quality]);
            }
            return true;
        }
        return false;
    }

    public function getDocUploadFolderAbs(): string
    {
        if ($this->public) {
            return Yii::getAlias($this->docUploadFolderPublic);
        }
        return Yii::getAlias($this->docUploadFolder);
    }

    public function getPath(): string
    {
        return realpath($this->getDocUploadFolderAbs()) . DIRECTORY_SEPARATOR . $this->getStorageFilename();
    }

    public function isUploadedfileImage(bool $allowSvg = true): bool
    {
        if (strpos($this->uploadedFile->type, 'image/') === 0) {
            if (!$allowSvg && $this->uploadedFile->type === 'image/svg') {
                return false;
            }
            return true;
        }
        return false;
    }

    public function getThumbnailPath(): string
    {
        return realpath($this->getDocUploadFolderAbs()) . DIRECTORY_SEPARATOR . $this->getThumbnailFileName();
    }

    public function getOrigFilename(): string
    {
        return $this->name . '.' . $this->extension;
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels(): array
    {
        return [
            'id' => Yii::t('app', 'ID'),
            'id_user' => Yii::t('app', 'User ID'),
            'name' => Yii::t('app.documents', 'Original Name'),
            'extension' => Yii::t('app.documents', 'Extension'),
            'title' => Yii::t('app', 'Title'),
            'description' => Yii::t('app', 'Description'),
            'bytes' => Yii::t('app.documents', 'Bytes'),
            'mime' => Yii::t('app.documents', 'Mime'),
            'width' => Yii::t('app.documents', 'Width'),
            'height' => Yii::t('app.documents', 'Height'),
            'uploadedFile' => Yii::t('app.documents', 'Pick a file'),
        ];
    }

    public function setWidthHeightByTempFile(): void
    {
        if ($this->isUploadedfileImage()) {
            list($this->width, $this->height) = getimagesize($this->uploadedFile->tempName);
        }
    }

    public function setFileInfo($filePath): void
    {
        $this->name = FileHelper::getFilename($filePath, true);
        $this->extension = FileHelper::getExtension($filePath);
        $this->bytes = filesize($filePath);
        $this->mime = FileHelper::getMimeTypeByExtension($filePath);
    }

    /**
     * Imgs are not available via browser. Only via a special URL that filters who can see what and then the file is streamed to the user.
     * Why? Users then cannot try random URLs in order to view images of other users.
     */
    public function getUrl(bool $thumb = false, bool $absolute = false): string
    {
        if ($this->public) {
            if ($thumb) {
                return Url::to('@web/uploads/' . $this->getThumbnailFileName(), $absolute);
            }
            return Url::to('@web/uploads/' . $this->getStorageFilename(), $absolute);
        }
        return Url::to(['@admin/documents/document/get-url', 'id' => $this->id, 'thumb' => (int)$thumb], $absolute);
    }

    /**
     * @param ?int|DocumentGroup $docGroup integer or DocumentGroup
     * @throws NotFoundHttpException
     */
    public function addToDocGroup(?int $docGroup): bool
    {
        if ($docGroup === null) {
            // No group used, no problem.
            return true;
        }

        $docGroup = DocumentGroup::findOne($docGroup);

        if (!$docGroup) {
            throw new NotFoundHttpException(Yii::t('app', 'The requested page does not exist.'));
        }

        $docGroupItem = new DocumentGroupItem();
        $docGroupItem->document_group_id = $docGroup->id;
        $docGroupItem->document_id = $this->id;
        $docGroupItem->position = DocumentGroupItem::find()->max('`position`') + 1;
        if (!$docGroupItem->save()) {
            foreach ($docGroupItem->getErrorSummary(true) as $error) {
                $this->addError('name', $error);
            }
            return false;
        }

        return true;
    }

    public function uploadAndSave(?int $idUser = null, ?int $groupId = null, string $attribute = 'uploadedFile'): bool
    {
        $this->load(Yii::$app->request->post());
        $this->uploadedFile = UploadedFile::getInstance($this, $attribute);
        if ($this->uploadedFile) {
            $this->id_user = $idUser;
            $this->name = $this->uploadedFile->baseName;
            $this->extension = $this->uploadedFile->extension;
            $this->bytes = $this->uploadedFile->size;
            $this->mime = $this->uploadedFile->type;
            $this->setWidthHeightByTempFile();
        }
        return $this->save() && $this->upload() && $this->addToDocGroup($groupId);
    }

    public function parseCsv(?int $rowCountLimit = null, string $separator = ';'): array
    {
        $fileHandle = fopen($this->getPath(), 'r');

        if (!$fileHandle) {
            throw new \Exception('Error opening file: ' . $this->getPath());
        }

        $result = [];
        $rowNr = 0;
        while ($row = fgetcsv($fileHandle, 0, $separator)) {
            $result[] = array_map(fn($value): string => trim($value), $row);
            if ($rowCountLimit && (++$rowNr >= $rowCountLimit)) {
                break;
            }
        }
        fclose($fileHandle);

        return $result;
    }

    public function getThumbnailIcon(array $imgOptions = []): string
    {
        return Html::img($this->getUrl(true), $imgOptions);
    }

    private function getStorageFilename(): string
    {
        return $this->id . '.' . $this->extension;
    }

    private function getThumbnailFileName(): string
    {
        return $this->id . '_' . $this->thumbnail_width . 'x' . $this->thumbnail_height . '.' . $this->extension;
    }
}
